local MountMacro, mm = ...
local _G = getfenv(0)

-- mm.L = _G.setmetatable({}, {__index=function(t,i) return i end})

-- local L = mm.L

-- L["Enable %s"] 																				= true
-- L["Enables / disables the addon"]														= true
-- L["Random Weight"]																			= true
-- L["Weight for the non-favorite mounts from 0 to 100. Use 0 if you only want the favorite mounts to be selected. Favorite mounts have a weight of 100."]
-- 																									= true
-- L["Macro Template"]																			= true
-- L["Template used to create the caracter specific mm macro. Use /macro to drag on one of your action buttons."]				
-- 																									= true
-- L["Reset Macro Template"]																	= true
-- L["Reset the macro to the default value."]											= true
-- L["Refresh Macro"]																			= true
-- L["Regenerate the macro based on the current template."]							= true
-- L["Resulting macro"]																			= true

local _G           = getfenv(0)
local pairs        = _G.pairs
local print        = _G.print
local rawget       = _G.rawget
local rawset       = _G.rawset
local setmetatable = _G.setmetatable
local sort         = _G.sort
local table        = _G.table

local function err(msg,...) _G.geterrorhandler()(msg:format(_G.tostringall(...)) .. " - " .. _G.time()) end

-- Code borrowed from Tekkub
local localized
local loc = _G.GetLocale()

-----------------------
--      English      --
-----------------------

-- The english table is not actually used for translation, just to validate that all the phares are listed on the WoWAce site.
local english = {}
local L = english -- Needs to be L[] in order to paste on the WoWAce site

L[ "Enable %s" ]                                                                                                                                          = true
L[ "Enables / disables the addon" ]                                                                                                                       = true
L[ "Macro Template" ]                                                                                                                                     = true
L[ "Macros" ]																																															 = true
L[ "Random Weight for Class Mounts" ]                                                                                                                     = true
L[ "Random Weight for Non Favorite" ]                                                                                                                     = true
L[ "Refresh Macro" ]                                                                                                                                      = true
L[ "Regenerate the macro based on the current template." ]                                                                                                = true
L[ "Reset Macro Template" ]                                                                                                                               = true
L[ "Reset the macro to the default value." ]                                                                                                              = true
L[ "Resulting macro" ]                                                                                                                                    = true
L[ "Template used to create the caracter specific mm macro. Use /macro to drag on one of your action buttons." ]                                          = true
L[ "Weight for the class mounts like the Warlock's Dreadsteed from 0 to 100. Use 0 if you do not want these mounts to be selected." ]                     = true
L[ "Weight for the non-favorite mounts from 0 to 100. Use 0 if you only want the favorite mounts to be selected. Favorite mounts have a weight of 100." ] = true
L[ "TOKEN_DESCRIPTION" ] = [[
MacroMount creates character specific macros named |cFF00FF00mm|r and |cFF00FF00mm2|r. Drag them to some of your action buttons to use.

<g> = Ground Mount
<f> = Flying Mount
<fg> = Ground or Flying Mount
<r> = Repair Mount
<uw> = Under Water Mount (Swim Bonus)
<ww> = Water Walking Mount
<pf> = Flying Passenger Mount
<pg> = Ground Passenger Mount
<pfg> = Flying or Ground Passenger Mount
<cm> = Current Mount (last one that was summoned)
]]

----------------------
--      French      --
----------------------

if loc == "frFR" then

localized = {}
-- localized["|cFF00FF00mm2|r"] = ""
-- localized["|cFF00FF00mm|r"] = ""
-- localized["Enable %s"] = ""
-- localized["Enables / disables the addon"] = ""
-- localized["Macros"] = ""
-- localized["Macro Template"] = ""
-- localized["Random Weight for Class Mounts"] = ""
-- localized["Random Weight for Non Favorite"] = ""
-- localized["Refresh Macro"] = ""
-- localized["Regenerate the macro based on the current template."] = ""
-- localized["Reset Macro Template"] = ""
-- localized["Reset the macro to the default value."] = ""
-- localized["Resulting macro"] = ""
-- localized["Template used to create the caracter specific mm macro. Use /macro to drag on one of your action buttons."] = ""
-- localized["TOKEN_DESCRIPTION"] = ""
-- localized["Weight for the class mounts like the Warlock's Dreadsteed from 0 to 100. Use 0 if you do not want these mounts to be selected."] = ""
-- localized["Weight for the non-favorite mounts from 0 to 100. Use 0 if you only want the favorite mounts to be selected. Favorite mounts have a weight of 100."] = ""


end

----------------------
--      German      --
----------------------

if loc == "deDE" then

localized = {}
localized["|cFF00FF00mm2|r"] = "|cFF00FF00mm2|r"
localized["|cFF00FF00mm|r"] = "|cFF00FF00mm|r"
localized["Enable %s"] = "%s aktivieren"
localized["Enables / disables the addon"] = "Aktiviert/Deaktiviert das Addon"
localized["Macros"] = "Makros"
localized["Macro Template"] = "Makrovorlage"
localized["Random Weight for Class Mounts"] = "Zufallsgewichtung für Klassenreittiere"
localized["Random Weight for Non Favorite"] = "Zufallsgewichtung für Nicht-Favoriten"
localized["Refresh Macro"] = "Makro erneuern"
localized["Regenerate the macro based on the current template."] = "Erzeugt das Makro basierend auf der momentanen Vorlage erneut."
localized["Reset Macro Template"] = "Makrovorlage zurücksetzen"
localized["Reset the macro to the default value."] = "Das Makro auf den Standardwert zurücksetzen."
localized["Resulting macro"] = "Resultierendes Makro"
localized["Template used to create the caracter specific mm macro. Use /macro to drag on one of your action buttons."] = "Vorlage, die verwendet wird, um das charakterspezifische Makro namens mm zu erstellen. Öffne das Makromenü (z.B. per /makro) und ziehe das Makro in deine Aktionsleiste."
localized["TOKEN_DESCRIPTION"] = [=[MountMacro erstellt charakterspezifische Makros namens |cFF00FF00mm|r und |cFF00FF00mm2|r. Ziehe diese Makros in deine Aktionsleisten, um sie zu verwenden.

<g> = Bodenreittier
<f> = Flugreittier
<fg> = Boden- oder Flugreittier
<r> = Reparaturreittier
<uw> = Unterwasserreittier (Schwimmbonus)
<ww> = Wasserwandeln-Reittier
<pf> = Flugpassagierreittier
<pg> = Bodenpassagierreittier
<pfg> = Flug- oder Bodenpassagierreittier
<cm> = Derzeitiges Reittier (das zuletzt beschworene)]=]
localized["Weight for the class mounts like the Warlock's Dreadsteed from 0 to 100. Use 0 if you do not want these mounts to be selected."] = "Gewichtung für die Klassenreittiere wie das Schreckensross der Hexenmeister; von 0 bis 100. Verwende 0, wenn du willst, dass diese Reittiere nicht ausgewählt werden."
localized["Weight for the non-favorite mounts from 0 to 100. Use 0 if you only want the favorite mounts to be selected. Favorite mounts have a weight of 100."] = "Gewichtung für nicht favorisierte Reittiere; von 0 bis 100. Verwende 0, wenn du willst, dass nur favorisierte Reittiere ausgewählt werden. Favorisierte Reittiere haben eine Gewichtung von 100."


end

----------------------
--      Spanish     --
----------------------

if loc == "esES" then

localized = {}
-- localized["|cFF00FF00mm2|r"] = ""
-- localized["|cFF00FF00mm|r"] = ""
-- localized["Enable %s"] = ""
-- localized["Enables / disables the addon"] = ""
-- localized["Macros"] = ""
-- localized["Macro Template"] = ""
-- localized["Random Weight for Class Mounts"] = ""
-- localized["Random Weight for Non Favorite"] = ""
-- localized["Refresh Macro"] = ""
-- localized["Regenerate the macro based on the current template."] = ""
-- localized["Reset Macro Template"] = ""
-- localized["Reset the macro to the default value."] = ""
-- localized["Resulting macro"] = ""
-- localized["Template used to create the caracter specific mm macro. Use /macro to drag on one of your action buttons."] = ""
-- localized["TOKEN_DESCRIPTION"] = ""
-- localized["Weight for the class mounts like the Warlock's Dreadsteed from 0 to 100. Use 0 if you do not want these mounts to be selected."] = ""
-- localized["Weight for the non-favorite mounts from 0 to 100. Use 0 if you only want the favorite mounts to be selected. Favorite mounts have a weight of 100."] = ""


end

----------------------------
-- Latin American Spanish --
----------------------------

if loc == "esMX" then

localized = {}
-- Little hack to use esES translation if a phrase doesn't exist in esMX
-- localized["|cFF00FF00mm2|r"] = ""
-- localized["|cFF00FF00mm|r"] = ""
-- localized["Enable %s"] = ""
-- localized["Enables / disables the addon"] = ""
-- localized["Macros"] = ""
-- localized["Macro Template"] = ""
-- localized["Random Weight for Class Mounts"] = ""
-- localized["Random Weight for Non Favorite"] = ""
-- localized["Refresh Macro"] = ""
-- localized["Regenerate the macro based on the current template."] = ""
-- localized["Reset Macro Template"] = ""
-- localized["Reset the macro to the default value."] = ""
-- localized["Resulting macro"] = ""
-- localized["Template used to create the caracter specific mm macro. Use /macro to drag on one of your action buttons."] = ""
-- localized["TOKEN_DESCRIPTION"] = ""
-- localized["Weight for the class mounts like the Warlock's Dreadsteed from 0 to 100. Use 0 if you do not want these mounts to be selected."] = ""
-- localized["Weight for the non-favorite mounts from 0 to 100. Use 0 if you only want the favorite mounts to be selected. Favorite mounts have a weight of 100."] = ""

-- localized["|cFF00FF00mm2|r"] = ""
-- localized["|cFF00FF00mm|r"] = ""
-- localized["Enable %s"] = ""
-- localized["Enables / disables the addon"] = ""
-- localized["Macros"] = ""
-- localized["Macro Template"] = ""
-- localized["Random Weight for Class Mounts"] = ""
-- localized["Random Weight for Non Favorite"] = ""
-- localized["Refresh Macro"] = ""
-- localized["Regenerate the macro based on the current template."] = ""
-- localized["Reset Macro Template"] = ""
-- localized["Reset the macro to the default value."] = ""
-- localized["Resulting macro"] = ""
-- localized["Template used to create the caracter specific mm macro. Use /macro to drag on one of your action buttons."] = ""
-- localized["TOKEN_DESCRIPTION"] = ""
-- localized["Weight for the class mounts like the Warlock's Dreadsteed from 0 to 100. Use 0 if you do not want these mounts to be selected."] = ""
-- localized["Weight for the non-favorite mounts from 0 to 100. Use 0 if you only want the favorite mounts to be selected. Favorite mounts have a weight of 100."] = ""


end

----------------------
--      Rusian      --
----------------------

if loc == "ruRU" then

localized = {}
-- localized["|cFF00FF00mm2|r"] = ""
-- localized["|cFF00FF00mm|r"] = ""
-- localized["Enable %s"] = ""
-- localized["Enables / disables the addon"] = ""
-- localized["Macros"] = ""
-- localized["Macro Template"] = ""
-- localized["Random Weight for Class Mounts"] = ""
-- localized["Random Weight for Non Favorite"] = ""
-- localized["Refresh Macro"] = ""
-- localized["Regenerate the macro based on the current template."] = ""
-- localized["Reset Macro Template"] = ""
-- localized["Reset the macro to the default value."] = ""
-- localized["Resulting macro"] = ""
-- localized["Template used to create the caracter specific mm macro. Use /macro to drag on one of your action buttons."] = ""
-- localized["TOKEN_DESCRIPTION"] = ""
-- localized["Weight for the class mounts like the Warlock's Dreadsteed from 0 to 100. Use 0 if you do not want these mounts to be selected."] = ""
-- localized["Weight for the non-favorite mounts from 0 to 100. Use 0 if you only want the favorite mounts to be selected. Favorite mounts have a weight of 100."] = ""


end

----------------------
--      Korean      --
----------------------

if loc == "koKR" then

localized = {}
-- localized["|cFF00FF00mm2|r"] = ""
-- localized["|cFF00FF00mm|r"] = ""
-- localized["Enable %s"] = ""
-- localized["Enables / disables the addon"] = ""
-- localized["Macros"] = ""
-- localized["Macro Template"] = ""
-- localized["Random Weight for Class Mounts"] = ""
-- localized["Random Weight for Non Favorite"] = ""
-- localized["Refresh Macro"] = ""
-- localized["Regenerate the macro based on the current template."] = ""
-- localized["Reset Macro Template"] = ""
-- localized["Reset the macro to the default value."] = ""
-- localized["Resulting macro"] = ""
-- localized["Template used to create the caracter specific mm macro. Use /macro to drag on one of your action buttons."] = ""
-- localized["TOKEN_DESCRIPTION"] = ""
-- localized["Weight for the class mounts like the Warlock's Dreadsteed from 0 to 100. Use 0 if you do not want these mounts to be selected."] = ""
-- localized["Weight for the non-favorite mounts from 0 to 100. Use 0 if you only want the favorite mounts to be selected. Favorite mounts have a weight of 100."] = ""


end

------------------------
-- Simplified Chinese --
------------------------

if loc == "zhCN" then

localized = {}
-- localized["|cFF00FF00mm2|r"] = ""
-- localized["|cFF00FF00mm|r"] = ""
localized["Enable %s"] = "\229\144\175\231\148\168 %s"
localized["Enables / disables the addon"] = "\229\144\175\231\148\168 / \231\166\129\231\148\168 \230\143\146\228\187\182"
-- localized["Macros"] = ""
localized["Macro Template"] = "\229\174\143\230\168\161\230\157\191"
localized["Random Weight for Class Mounts"] = "\233\154\143\230\156\186\232\129\140\228\184\154\229\157\144\233\170\145"
localized["Random Weight for Non Favorite"] = "\233\154\143\230\156\186\229\157\144\233\170\145(\233\153\164\230\148\182\232\151\143\229\164\150)"
localized["Refresh Macro"] = "\229\136\183\230\150\176\229\174\143"
localized["Regenerate the macro based on the current template."] = "\233\135\141\230\150\176\231\148\159\230\136\144\229\159\186\228\186\142\229\189\147\229\137\141\230\168\161\230\157\191\231\154\132\229\174\143\227\128\130"
localized["Reset Macro Template"] = "\233\135\141\231\189\174\229\174\143\230\168\161\230\157\191"
localized["Reset the macro to the default value."] = "\233\135\141\231\189\174\229\174\143\228\184\186\233\187\152\232\174\164\229\128\188\227\128\130"
localized["Resulting macro"] = "\231\148\159\230\136\144\229\174\143"
-- localized["Template used to create the caracter specific mm macro. Use /macro to drag on one of your action buttons."] = ""
-- localized["TOKEN_DESCRIPTION"] = ""
-- localized["Weight for the class mounts like the Warlock's Dreadsteed from 0 to 100. Use 0 if you do not want these mounts to be selected."] = ""
-- localized["Weight for the non-favorite mounts from 0 to 100. Use 0 if you only want the favorite mounts to be selected. Favorite mounts have a weight of 100."] = ""


end

-------------------------
-- Traditional Chinese --
-------------------------

if loc == "zhTW" then

localized = {}
-- localized["|cFF00FF00mm2|r"] = ""
-- localized["|cFF00FF00mm|r"] = ""
-- localized["Enable %s"] = ""
-- localized["Enables / disables the addon"] = ""
-- localized["Macros"] = ""
-- localized["Macro Template"] = ""
-- localized["Random Weight for Class Mounts"] = ""
-- localized["Random Weight for Non Favorite"] = ""
-- localized["Refresh Macro"] = ""
-- localized["Regenerate the macro based on the current template."] = ""
-- localized["Reset Macro Template"] = ""
-- localized["Reset the macro to the default value."] = ""
-- localized["Resulting macro"] = ""
-- localized["Template used to create the caracter specific mm macro. Use /macro to drag on one of your action buttons."] = ""
-- localized["TOKEN_DESCRIPTION"] = ""
-- localized["Weight for the class mounts like the Warlock's Dreadsteed from 0 to 100. Use 0 if you do not want these mounts to be selected."] = ""
-- localized["Weight for the non-favorite mounts from 0 to 100. Use 0 if you only want the favorite mounts to be selected. Favorite mounts have a weight of 100."] = ""


end


-- Metatable majicks... makes localized table fallback to english, or fallback to the index requested.
-- This ensures we ALWAYS get a value back, even if it's the index we requested originally
mm.L = localized and setmetatable(localized, {__index = function(t,i) return english[i] ~= true and english[i] or i end})
	or setmetatable({}, {__index = function(t,i)
		-- Get the error only the first time a missing string is found
		if rawget(english, i) and rawget(english, i) ~= true then
			return rawget(english, i)
		elseif rawget(english, i) ~= true then
			rawset(english, i, true)
			rawset(t, i, i)
			err("Missing translation: %s",i)
		end
		return i 
end})

function mm:DumpLocales()
	local t = {}
	for k in pairs(english) do table.insert(t,k) end
	sort(t)
	for i=1,#t do
		print(("L[ \"%s\" ] = true"):format(t[i]:gsub('\\','\\\\'):gsub('"','\\"')))
	end
end
